<?php
/*------------------------------------------------------------------------
# News Show SP1 - News display module by JoomShaper.com
# ------------------------------------------------------------------------
# author    JoomShaper http://www.joomshaper.com
# Copyright (C) 2010 - 2012 JoomShaper.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomshaper.com
-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');
$k2route = JPATH_SITE.'/components/com_k2/helpers/route.php';
$k2utilities = JPATH_SITE.'/components/com_k2/helpers/utilities.php';
if (file_exists($k2route))
	require_once($k2route);
	
if (file_exists($k2utilities))
	require_once($k2utilities);
	
abstract class modNSSP1K2Helper {

	static function getList($params, $uniqid){
	
			$article_count	= $params->get('article_count',3);
			$link_count		= $params->get('link_count',3);
			$links		    = $params->get('links',1)==1 ? true : false;
			$count 			= $links ? $article_count + $link_count : $article_count;
			$thumbratio		= $params->get('thumbratio', 1) ? true : false;
			$thumbwidth		= trim($params->get('thumbwidth', 50));
			$thumbheight	= trim($params->get('thumbheight', 50));			
		
			$cid 		= $params->get('k2catids', NULL);

			$user 		= JFactory::getUser();
			$aid 		= $user->get('aid');
			$db 		= JFactory::getDBO();

			$jnow 		= JFactory::getDate();
			$now 		= $jnow->toSql();
			$nullDate 	= $db->getNullDate();

			$query = "SELECT a.*, c.name as categoryname,c.id as categoryid, c.alias as categoryalias, c.params as categoryparams".
			" FROM #__k2_items as a".
			" LEFT JOIN #__k2_categories c ON c.id = a.catid";
			$query .= " WHERE a.published = 1 AND a.access IN(".implode(',', $user->getAuthorisedViewLevels()).") AND a.trash = 0 AND c.published = 1 AND c.access IN(".implode(',', $user->getAuthorisedViewLevels()).")  AND c.trash = 0";
					
			// User filter
			$userId = JFactory::getUser()->get('id');
			switch ($params->get('user_id'))
			{
				case 'by_me':
					$query .= ' AND (a.created_by = ' . (int) $userId . ' OR a.modified_by = ' . (int) $userId . ')';
					break;
				case 'not_me':
					$query .= ' AND (a.created_by <> ' . (int) $userId . ' AND a.modified_by <> ' . (int) $userId . ')';
					break;

				case '0':
					break;

				default:
					$query .= ' AND (a.created_by = ' . (int) $userId . ' OR a.modified_by = ' . (int) $userId . ')';
					break;				
			}

			//Added Category
			if (!is_null($cid)) {
				if (is_array($cid)) {
					JArrayHelper::toInteger($cid);
					$query .= " AND a.catid IN(".implode(',', $cid).")";
				} else {
					$query .= " AND a.catid=".(int)$cid;
				}
			}

			//  Featured items filter
			if ($params->get('show_featured') == '0')
			$query .= " AND a.featured != 1";

			if ($params->get('show_featured') == '1')
			$query .= " AND a.featured = 1";

			// ensure should be published
			$query .= " AND ( a.publish_up = ".$db->Quote($nullDate)." OR a.publish_up <= ".$db->Quote($now)." )";
			$query .= " AND ( a.publish_down = ".$db->Quote($nullDate)." OR a.publish_down >= ".$db->Quote($now)." )";
			
			//Ordering
			$orderby = $params->get('ordering', 'a.ordering') . ' ' . $params->get('ordering_direction', 'ASC'); //ordering

			$query .= " ORDER BY ".$orderby;
			$db->setQuery($query, 0, $count);
			$items = $db->loadObjectList();
			
			require_once (JPATH_SITE.'/components/com_k2/models/item.php');
			$model = new K2ModelItem;
			
			if (count($items)) {
				foreach ($items as $item) {
					
					///////new is coming
					if (! empty($item->created_by_alias)) {
						$item->author 	= $item->created_by_alias;
					} else {
						$author 		= JFactory::getUser($item->created_by);
						$item->author 	= $author->name;
					}
					
					$item->created 		= $item->created;
					$item->hits 		= $item->hits;
					if ($params->get('showimage', 1))
						$item->image 	= self::getImage($item->id, $item->introtext, $thumbwidth, $thumbheight, $thumbratio, $uniqid)->image;
					$item->title 		= self::prepareTitle($item->title,$params );
					$item->introtext 	= self::prepareContent($item->introtext,$params);
					$item->link 		= urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
					
					//Extra fields
					if ($params->get('itemExtraFields')) {
						$item->extra_fields = $model->getItemExtraFields($item->extra_fields);
					}
					//Comments counter
					if ($params->get('showcomments'))
					$item->numOfComments = $model->countItemComments($item->id);

					$rows[] = $item;
				}
				return $rows;
			}
	}
	
	static function getImage($id, $text, $thumbwidth, $thumbheight, $thumbratio, $uniqid) {

		if (JFile::exists(JPATH_SITE . '/media/k2/items/cache/' . md5("Image" . $id) . '_XL.jpg')) {
			$image_path 	= 'media/k2/items/cache/' . md5("Image" . $id) . '_XL.jpg';
		} else {
			preg_match('/< *img[^>]*src *= *["\']?([^"\']*)/i', $text, $matches);	
			if (isset($matches[1])) {
				$image_path = $matches[1];
			}		
		}

		$images = new stdClass();
		$images->image = false;
		
		$paths = array();
		if ($image_path) {
			// remove any / that begins the path
			if (substr($image_path, 0 , 1) == '/') $image_path = substr($image_path, 1);
			
			// create a thumb filename
			$file_div = strrpos($image_path,'.');
			$thumb_ext = substr($image_path, $file_div);
			$thumb_prev = substr($image_path, 0, $file_div);
			$thumb_path = $thumb_prev . "_thumb" . $uniqid . $thumb_ext;
				
			// check to see if this file exists, if so we don't need to create it
			if (function_exists("gd_info")) {
				// file doens't exist, so create it and save it
				if (!class_exists("spThumbnail")) include_once('class.spThumbnail.php');
				
				//Check existing thumbnails dimensions
				if (file_exists($thumb_path)) {
					$size = GetImageSize( $thumb_path );
					$currentWidth=$size[0];
					$currentHeight=$size[1];
				}
				
				//Creating thumbnails		
                if (!file_exists($thumb_path) || $currentWidth!=$thumbwidth || $currentHeight!=$thumbheight ) {
					$thumb = new spThumbnail;
					$thumb->new_width = $thumbwidth;
					$thumb->new_height = $thumbheight;
					$thumb->image_to_resize = $image_path; // Full Path to the file
					$thumb->ratio = $thumbratio; // Keep Aspect Ratio?
					$thumb->save = $thumb_path;
					$process = $thumb->resize();
    			}
			}
			
			$images->image = $thumb_path;
		} 
		return $images;		
		
	}
	
	static function prepareContent($text, $params) {
		
		$text = JFilterOutput::cleanText($text);

	    // Description limit
		$desclimit=$params->get('desclimit',30);
		switch ($params->get('desclimitas')) {
			case 0 :
				$text = explode(' ',$text);
				$sep = (count($text)>$desclimit) ? '...' : '';
				$text=implode(' ', array_slice($text,0,$desclimit)) . $sep;
				break;
			case 1 :
				$sep = (strlen($text)>$desclimit) ? '...' : '';
				$text=utf8_substr($text,0,$desclimit) . $sep;
				break;
			case 2 :
				$text = $text;
				break;
			default :
				$text = explode(' ',$text);
				$sep = (count($text)>$desclimit) ? '...' : '';
				$text=implode(' ', array_slice($text,0,$desclimit)) . $sep;
				break;
		}		
		
		return $text;
	}	
	
	static function prepareTitle($text, $params) {
		$text=htmlspecialchars($text);
		// Title limit
		$titlelimit=$params->get('titlelimit',20);
		switch ($params->get('titleas')) {
			case 0 :
				$text = explode(' ',$text);
				$sep = (count($text)>$titlelimit) ? '...' : '';
				$text=implode(' ', array_slice($text,0,$titlelimit)) . $sep;
				break;
			case 1 :
				$sep = (strlen($text)>$titlelimit) ? '...' : '';
				$text=utf8_substr($text,0,$titlelimit) . $sep;
				break;
			case 2 :
				$text = $text;
				break;
			default :
				$text = explode(' ',$text);
				$sep = (count($text)>$titlelimit) ? '...' : '';
				$text=implode(' ', array_slice($text,0,$titlelimit)) . $sep;
				break;				
		}		
		
		return $text;
	}
}